'BASIC converted from flowchart: 
'C:\SC MICRO PROJECTS\PROJECT23.CAD
'Converted on DATE at TIME
main:		let w8=0				'Clear previous average for no noise
		high 1				'Turn on Green LED
		pause 10000				'Let system settle			
		readadc 2,b12			'Read collector voltage
		for b0 = 1 to 10			'Start measure of quiet value
		readadc 2,b13			'Get First reading
		if b13 >= b12 then		'Higher or equal to collector voltage?	
			b11=b13-b12			'If yes subtract to get difference
		else					'If not
			b11=b12-b13			'Subtract to get difference
		endif					'End difference routine 
		if b11 > 3 then main		'Difference > 3 too noisy, start over
		If w8 <> 0 then			'Not the first reading? --------------------
			w8 = w8 + b13		'If yes then add to average                 |
			w8 = w8/2			'Calculate new average           Change b10 to w8
		else					'Yes this is first reading                  |
			w8 = b13			'Set first reading as the average           |
		endif					'End average routine -----------------------
		next b0				'Get next reading
		serout 0,N4800,("zero level = ",#b16,13,10)	'Print no noise level 2400->4800
		low 1					'Turn off green light
		
label_79:	let b4= 80				'Start address for data storage
		let b6= 0				'Counter between claps
label_22:	setint  %00010000,%00010000	'Interupt on High at AC coupled input 4 8,8-->%
		if b4> 95 then label_79		'Start again after 2nd clap
		pause 10				'Pause 20 milliseconds
		 inc b6				'then add one to b6
		if b6> 254 then label_79	'2.5 seconds are up
		goto label_22			'otherwise keep looking for 2nd clap
interrupt:	
		
		let b5=b4+ 6			'Set window to 6 data points
		 for b0 = b4 to b5		'start reading data
		readadc  2,b13			'read data pin 2 and place it in b13 variable
		poke b0,b13				'store reading in storage area
		pause 2				'pause for 2 ms
		 next b0				'continue reading group of 6 data points
		pause 500				'wait for .25 seconds to get quiet data
		let b4=b4+ 6			'set storage area for quiet data
		let b5=b4+ 6			'set window for 6 data points
		 for b0 = b4 to b5		'start reading quiet data
		readadc  2,b13			'read quiet data on pin 2
		poke b0,b13				'store in storage area for quiet data
		pause 2				'pause for 2 ms
		 next b0				'continue reading all 6 points
		if b4> 91 then label_58		'If 2nd clap is recorded go to dump data
		let b4=b4+ 6			'If no 2nd clap set data storage
		let b6= 0				'Reset counter for maximum of 5 sec.
label_5F:	return

label_58:	 for b0 = 80 to 103		'Set data read for all data stored
		peek b0,b1				'Get data
			if b1 > b16 then 		'If reading is larger than quiet b13-->b16
		b2=b1-b16				'Subtract quiet from reading  b13-->b16
		else					'If reading less than or equal to quiet
		b2=b16-b1				'Subtarct reading from quiet number b13-->b16
		endif					'end difference routine
		serout 0,N4800,(#b2,",  ")	'Send to terminal {Baude rate changed & in 37}
		 next b0				'Repeat for all data
		serout 0,N4800,("end",13,10)	'Send end of data and start new line
		goto label_5F			'Return to main program.


